#include <caml/alloc.h>
#include <caml/callback.h>
#include <caml/custom.h>
#include <caml/fail.h>
#include <caml/memory.h>
#include <caml/mlvalues.h>

CAMLprim value do_it(value func)
{
    CAMLparam1(func);
    char s[256];
    CAMLlocal2(v, result);

    printf("Enter a string: ");
    scanf("%s", s);
    printf("C says you entered %s\n", s);
    v = copy_string(s);
    result = callback_exn(func, v);
    if (Is_exception_result(result))
        printf("Caught exception\n");
    CAMLreturn(Val_unit);
}
